#!/bin/sh
#BUSY Signal
#echo 26 > /sys/class/gpio/export
#echo out > /sys/class/gpio/gpio26/direction
#echo 0 > /sys/class/gpio/gpio26/value
#echo "OUTPUT BUSY SIGNAL"


#USB init wait
devs=0
devb=-1
devb2=-2
mounts=0
mountb=0
while [ $devb2 -ne $devs ] || [ $mountb -ne $mounts ]
do
  devb2=${devb}
  devb=${devs}
  mountb=${mounts}
  mounts=`find /dev/ -maxdepth 1 | grep -E -i "^/dev/sd.[1-9]" | wc -l`
  devs=`lsusb | wc -l`
  echo "mount: $mounts   USBdev: $devs"
  sleep 1
done


#USB Mount & Disabled Partition error mark
count=0
mounts=`find /dev/ -maxdepth 1 | grep -E -i "^/dev/sd.[1-9]"`
for m in $mounts;
do
	sudo mount ${m} /media/usb${count} -t vfat -o umask=000,async,noexec,nodev,noatime,nodiratime
	if [ $? -eq 0 ]; then
		count=`expr ${count} + 1`
		BPB_FATSZ16=`sudo xxd -p -s 22 -l 2 ${m}`
		if [ $BPB_FATSZ16 = "0000" ]; then
			#FAT32
			RESV=`sudo xxd -p -s 65 -l 1 ${m}`
			if [ $RESV = "01" ]; then
				sudo dd if=/dev/zero bs=1 count=1 seek=65 of=${m}
			fi
		else
			#FAT12,16
			RESV=`sudo xxd -p -s 37 -l 1 ${m}`
			if [ $RESV = "01" ]; then
				sudo dd if=/dev/zero bs=1 count=1 seek=37 of=${m}
			fi
		fi
	fi
done


#External MicroSD partition mount
if [ -e /dev/mmcblk0p3 ]; then
	if [ `find /media/xsd | wc -l` = 0 ]; then
		mkdir /media/xsd
	fi
	sudo mount /dev/mmcblk0p3 /media/xsd -t vfat -o umask=000,async,noexec,nodev,noatime,nodiratime
fi


#Search Image
cd `dirname $0`
files=`find /media/ -maxdepth 2 | sort | grep -E -i /rascsi_id[0-6]`


#Generate RaSCSI command line
arg="sudo ./rascsi "

#External Option
extop=""
if [ -e /media/xsd/rascsi.txt ]; then
	extop=`cat /media/xsd/rascsi.txt`
	arg="${arg} ${extop} "
fi

for f in $files;
do
	id=`echo ${f} | sed -e "s/.*rascsi_id\([0-6]\).*/\1/g"`
	arg="${arg} -id${id} ${f}"
done

if [ ! -e /media/xsd/rascsi.txt ]; then
	arg="${arg} -id5 cd -id6 bridge "
fi

arg="${arg} >/dev/tty1"

#Execute
./loop.sh &
echo $arg
$arg


